/* LayoutRight.c generated by valac 0.48.17, the Vala compiler
 * generated from LayoutRight.vala, do not modify */

/*
* Copyright (c) 2018 (https://github.com/phase1geo/Minder)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 2 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*
* Authored by: Trevor Williams <phase1geo@gmail.com>
*/

#include <glib-object.h>
#include <glib.h>
#include <float.h>
#include <math.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>

#define TYPE_LAYOUT (layout_get_type ())
#define LAYOUT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_LAYOUT, Layout))
#define LAYOUT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_LAYOUT, LayoutClass))
#define IS_LAYOUT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_LAYOUT))
#define IS_LAYOUT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_LAYOUT))
#define LAYOUT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_LAYOUT, LayoutClass))

typedef struct _Layout Layout;
typedef struct _LayoutClass LayoutClass;
typedef struct _LayoutPrivate LayoutPrivate;
typedef enum  {
	NODE_SIDE_LEFT = 1,
	NODE_SIDE_TOP = 2,
	NODE_SIDE_RIGHT = 4,
	NODE_SIDE_BOTTOM = 8
} NodeSide;

#define TYPE_NODE_SIDE (node_side_get_type ())

#define TYPE_NODE (node_get_type ())
#define NODE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_NODE, Node))
#define NODE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_NODE, NodeClass))
#define IS_NODE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_NODE))
#define IS_NODE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_NODE))
#define NODE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_NODE, NodeClass))

typedef struct _Node Node;
typedef struct _NodeClass NodeClass;

#define TYPE_NODE_BOUNDS (node_bounds_get_type ())
typedef struct _NodeBounds NodeBounds;

#define TYPE_LAYOUT_RIGHT (layout_right_get_type ())
#define LAYOUT_RIGHT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_LAYOUT_RIGHT, LayoutRight))
#define LAYOUT_RIGHT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_LAYOUT_RIGHT, LayoutRightClass))
#define IS_LAYOUT_RIGHT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_LAYOUT_RIGHT))
#define IS_LAYOUT_RIGHT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_LAYOUT_RIGHT))
#define LAYOUT_RIGHT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_LAYOUT_RIGHT, LayoutRightClass))

typedef struct _LayoutRight LayoutRight;
typedef struct _LayoutRightClass LayoutRightClass;
typedef struct _LayoutRightPrivate LayoutRightPrivate;
enum  {
	LAYOUT_RIGHT_0_PROPERTY,
	LAYOUT_RIGHT_NUM_PROPERTIES
};
static GParamSpec* layout_right_properties[LAYOUT_RIGHT_NUM_PROPERTIES];

struct _NodeBounds {
	gdouble x;
	gdouble y;
	gdouble width;
	gdouble height;
};

struct _Layout {
	GObject parent_instance;
	LayoutPrivate * priv;
	gdouble _rt_gap;
};

struct _LayoutClass {
	GObjectClass parent_class;
	NodeSide (*side_mapping) (Layout* self, NodeSide side);
	void (*initialize) (Layout* self, Node* parent);
	void (*bbox) (Layout* self, Node* parent, gint side_mask, NodeBounds* result);
	void (*adjust_tree) (Layout* self, Node* parent, gint child_index, gint side_mask, gdouble amount);
	void (*adjust_tree_all) (Layout* self, Node* n, NodeBounds* prev, gdouble amount, const gchar* msg);
	void (*propagate_side) (Layout* self, Node* parent, NodeSide side);
	NodeSide (*get_side) (Layout* self, Node* n);
	void (*set_side) (Layout* self, Node* current);
	void (*handle_update_by_edit) (Layout* self, Node* n, gdouble diffw, gdouble diffh);
	void (*handle_update_by_fold) (Layout* self, Node* n);
	gdouble (*get_insert_adjust) (Layout* self, Node* child);
	void (*handle_update_by_insert) (Layout* self, Node* parent, Node* child, gint pos);
	void (*handle_update_by_delete) (Layout* self, Node* parent, gint index, NodeSide side, gdouble size);
	void (*position_root) (Layout* self, Node* last, Node* n);
};

struct _LayoutRight {
	Layout parent_instance;
	LayoutRightPrivate * priv;
};

struct _LayoutRightClass {
	LayoutClass parent_class;
};

static gpointer layout_right_parent_class = NULL;

GType layout_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Layout, g_object_unref)
GType node_side_get_type (void) G_GNUC_CONST;
GType node_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Node, g_object_unref)
GType node_bounds_get_type (void) G_GNUC_CONST;
NodeBounds* node_bounds_dup (const NodeBounds* self);
void node_bounds_free (NodeBounds* self);
GType layout_right_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (LayoutRight, g_object_unref)
NodeSide layout_side_mapping (Layout* self,
                              NodeSide side);
void layout_set_side (Layout* self,
                      Node* current);
LayoutRight* layout_right_new (void);
LayoutRight* layout_right_construct (GType object_type);
Layout* layout_new (void);
Layout* layout_construct (GType object_type);
void layout_set_name (Layout* self,
                      const gchar* value);
void layout_set_icon (Layout* self,
                      const gchar* value);
void layout_set_balanceable (Layout* self,
                             gboolean value);
static NodeSide layout_right_real_side_mapping (Layout* base,
                                         NodeSide side);
static void layout_right_real_set_side (Layout* base,
                                 Node* current);
void node_set_side (Node* self,
                    NodeSide value);
static GType layout_right_get_type_once (void);

LayoutRight*
layout_right_construct (GType object_type)
{
	LayoutRight * self = NULL;
	self = (LayoutRight*) layout_construct (object_type);
	layout_set_name ((Layout*) self, _ ("To right"));
	layout_set_icon ((Layout*) self, "minder-layout-right-symbolic");
	layout_set_balanceable ((Layout*) self, FALSE);
	return self;
}

LayoutRight*
layout_right_new (void)
{
	return layout_right_construct (TYPE_LAYOUT_RIGHT);
}

static NodeSide
layout_right_real_side_mapping (Layout* base,
                                NodeSide side)
{
	LayoutRight * self;
	NodeSide result = 0;
	self = (LayoutRight*) base;
	result = NODE_SIDE_RIGHT;
	return result;
}

static void
layout_right_real_set_side (Layout* base,
                            Node* current)
{
	LayoutRight * self;
	self = (LayoutRight*) base;
	g_return_if_fail (current != NULL);
	node_set_side (current, NODE_SIDE_RIGHT);
}

static void
layout_right_class_init (LayoutRightClass * klass,
                         gpointer klass_data)
{
	layout_right_parent_class = g_type_class_peek_parent (klass);
	((LayoutClass *) klass)->side_mapping = (NodeSide (*) (Layout*, NodeSide)) layout_right_real_side_mapping;
	((LayoutClass *) klass)->set_side = (void (*) (Layout*, Node*)) layout_right_real_set_side;
}

static void
layout_right_instance_init (LayoutRight * self,
                            gpointer klass)
{
}

static GType
layout_right_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (LayoutRightClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) layout_right_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (LayoutRight), 0, (GInstanceInitFunc) layout_right_instance_init, NULL };
	GType layout_right_type_id;
	layout_right_type_id = g_type_register_static (TYPE_LAYOUT, "LayoutRight", &g_define_type_info, 0);
	return layout_right_type_id;
}

GType
layout_right_get_type (void)
{
	static volatile gsize layout_right_type_id__volatile = 0;
	if (g_once_init_enter (&layout_right_type_id__volatile)) {
		GType layout_right_type_id;
		layout_right_type_id = layout_right_get_type_once ();
		g_once_init_leave (&layout_right_type_id__volatile, layout_right_type_id);
	}
	return layout_right_type_id__volatile;
}

